﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq.Expressions;
using System.Windows;
using Infragistics.Controls.Grids;
using Infragistics.Olap;
using Infragistics.Olap.Data;
using Infragistics.Olap.FlatData;
using System.Windows.Data;
using System.IO;
using Infragistics.Olap.Excel;
using System.Data;
using System.Reflection;

namespace PivotGridTestApp
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private string _FilenName;
        private double _prevoiusTotalCount = 0;
        private double _prevoiusExceptionCount = 0;
        private int _count = 1;
        private DataTable _DataTble;
        public MainWindow()
        {
            InitializeComponent();           
        }

        private DataTable LoadExcelFileData()
        {
            DataTable dt = null;
            try
            {
                string connection = string.Format("provider=Microsoft.Jet.OLEDB.4.0;Data Source='{0}';Extended Properties=Excel 8.0;",_FilenName);
               // string connection = string.Format("Provider=Microsoft.ACE.OLEDB.12.0;Data Source='{0}';Extended Properties='Excel 12.0 Xml;HDR=Yes;",_FilenName);
                System.Data.OleDb.OleDbConnection MyConnection;            
                System.Data.OleDb.OleDbDataAdapter MyCommand;
                MyConnection = new System.Data.OleDb.OleDbConnection(connection);
                MyConnection.Open();
                dt = new DataTable();
                dt = MyConnection.GetOleDbSchemaTable(System.Data.OleDb.OleDbSchemaGuid.Tables, null);
                string sheetName = dt.Rows[0]["TABLE_NAME"].ToString();
                MyCommand = new System.Data.OleDb.OleDbDataAdapter("select * from [" + sheetName + "]", MyConnection);
              //  MyCommand.TableMappings.Add("Table", "TestTable");               
                MyCommand.Fill(dt);                
                MyConnection.Close();
               
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            return dt;
        }

        private void BuildDataSource()
        {
            DynamicTypeBuilder typeBuilder = new DynamicTypeBuilder
            {
                DynamicAssemblyName = "MyAssembly",
                DynamicTypeName = "Pane"
            };

            IList<DynamicTypePropertyInfo> properties = new List<DynamicTypePropertyInfo>();
            foreach (DataColumn column in _DataTble.Columns)
            {
                DynamicTypePropertyInfo propertyInfo = new DynamicTypePropertyInfo
                {
                    PropertyName = column.ColumnName,
                    PropertyType = column.DataType
                };                
                properties.Add(propertyInfo);
            }

            Type dynamicType = typeBuilder.GenerateType(properties);

            Type listType = typeof(List<>);
            Type genericListType = listType.MakeGenericType(dynamicType);
            IList list = (IList)Activator.CreateInstance(genericListType);

            foreach (DataRow dataRow in _DataTble.Rows)
            {
                object myDynamicInstance = Activator.CreateInstance(dynamicType);
                foreach (DataColumn column in _DataTble.Columns)
                {
                    PropertyInfo propertyVal = dynamicType.GetProperty(column.ColumnName);
                    if (dataRow[column] != DBNull.Value)
                    {
                        propertyVal.SetValue(myDynamicInstance, dataRow[column], null);
                    }
                }

                list.Add(myDynamicInstance);
            }
            

            FlatDataSource flatDataSource = new FlatDataSource()
            {
                ItemsSource = list,
                Cube = DataSourceBase.GenerateInitialCube("Pane"),
                Rows = DataSourceBase.GenerateInitialItems("[Row]"),
                Columns = DataSourceBase.GenerateInitialItems("[Column]"),
                Measures = DataSourceBase.GenerateInitialItems("[Row]")
            };


            dataSelector.DataSource = flatDataSource;
            pivotGrid.DataSource = flatDataSource;
        }

        private void Browse_Click(object sender, RoutedEventArgs e)
        {
            _FilenName = string.Empty;
            // Create OpenFileDialog
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();

            // Set filter for file extension and default file extension
            dlg.DefaultExt = ".xls";
            dlg.Filter = "Excel (.xls)|*.xls";

            // Display OpenFileDialog by calling ShowDialog method
            Nullable<bool> result = dlg.ShowDialog();
            if (result == true)
            {
                // Open document
                _FilenName = dlg.FileName;               
            }

            _DataTble = LoadExcelFileData();
            BuildDataSource();
        }
    }
   
 
}
